import 'dart:io';

import 'core.dart';
import 'env.dar';
import 'printer.dart' as printer;
import 'reader.dart' as reader;
import 'types.dart';

final Env replEnv = new Env()

void setupEnv(List <String> argv) {
  ns.forEach((sym, fun) => replEnv.set(sym, fun));

  replEnv.set(new MalSymbol('eval'),
    new MalBuiltin((List<MalType>args) => EVAL(args.single, replEnv)));

  replEnv.set(new MalSymbol('*ARGV*'),
    new MalList(argv.map((s) => new MalString(s)).toList()));

  replEnv.set(new MalSymbol('*host-language*'), new MalString('dart'));

}

bool isMacroCall(MalType ast, Env env) {
  if (ast is MalList) {
    if (ast.isNotEmpty && ast.first is MalSymbol) {
      try {
        var value = env.get(ast.first);
        if (value is MalCallable) {
          return value.isMacro;
        }
      } on NotFoundException {
        return false;
      }
    }
  }
  return false;
}

MalType macroexpand(MalType ast, Env env) {
  while (isMacroCall(ast, env)) {
    var macroSymbol = (ast as MalList).first;
    var macro = env.get(macroSymbol) as MalCallable;
    ast = macro((ast as MalList).sublist(1));
  }
  return ast;
}

MalType quasiquote(MalType ast) {
  bool isPair(MalType ast) {
    return ast is MalIterable && ast.isNotEmpty;
  }


}